#!/bin/sh
session()
{
  read req
  file="`echo "$req" | awk '{ print $2 }'`"
#  if [ "$file" = "/pic.png" ]; then
#    echo "HTTP/1.1 200 OK"
#    echo "Server: bash+nc"
#    echo "Content-type: image/png"
#    echo "Connection: close"
#    echo "Content-length: `du -b cam1.png | sed -e "s/[ \t].*//;"`"
#    echo ""
#    cat cam1.png
#  else
    echo "HTTP/1.1 404 File not found"
    echo "Server: bash+nc"
    echo "Content-type: text"
    echo "Connection: close"
    echo "Content-length: `du -b 404 | sed -e "s/[ \t].*//;"`"
    echo ""
    cat 404
#  fi
}

sslcert=''
prop=''
for x in $@; do
  if [ "$prop" = "-ssl" ]; then
    sslcert="$x"
    prop=''
  elif [ "$x" = "-ssl" ]; then
    prop='-ssl';
  else
    echo "Unknown argument $x" >&2
    exit 1
  fi
done

rm -f /tmp/httpd
mkfifo /tmp/httpd
while true; do
  if [ "$sslcert" = "" ]; then
    if nc --help 2> /dev/null | grep -q GNU; then # GNU nc
      ./httpd_session.sh < /tmp/httpd | nc -c -l -p 8000 > /tmp/httpd
    else # BSD nc
      ./httpd_session.sh < /tmp/httpd | nc -l 8000 > /tmp/httpd
    fi
  else
    ./httpd_session.sh < /tmp/httpd | openssl s_server -quiet -accept 8443 -cert "$sslcert" > /tmp/httpd
  fi
done
